//---------------------------------------------------------------------------
// Copyright 2010-2017 Joe Lowe
//
// Permission is granted to any person obtaining a copy of this Software,
// to deal in the Software without restriction, including the rights to use,
// copy, modify, merge, publish, distribute, sublicense, and sell copies of
// the Software.
//
// The above copyright and permission notice must be left intact in all
// copies or substantial portions of the Software.
//
// THE SOFTWARE IS WITHOUT WARRANTY.
//---------------------------------------------------------------------------
// file name:  ptlimits.h
// created:    2010.03.11
//    Subset of definitions from ISO C89 limits.h, for systems/compilers
//    that do not supply correct definitions.
//---------------------------------------------------------------------------
#ifndef PTLIMITS_H
#define PTLIMITS_H
#ifdef __cplusplus
extern "C" {
#endif

   // Linux kernel limits definitions are incomplete. What
   // are provided contain type casts, making them unusable
   // in preprocessor constructs.
#undef INT_MIN
#undef INT_MAX
#undef UINT_MAX
#undef SHRT_MIN
#undef SHRT_MAX
#undef USHRT_MAX
#undef LONG_MIN
#undef LONG_MAX
#undef ULONG_MAX
#undef LLONG_MIN
#undef LLONG_MAX
#undef ULLONG_MAX
#undef SIZE_MAX
#undef WCHAR_MIN
#undef WCHAR_MAX

#define CHAR_MIN    (-128)
#define CHAR_MAX      127
#define SCHAR_MIN   (-128)
#define SCHAR_MAX     127
#define UCHAR_MAX     255
#define SHRT_MIN    (-32768)
#define SHRT_MAX      32767
#define USHRT_MAX     0xFFFF
#define INT_MIN     (-2147483647-1)
#define INT_MAX       2147483647
#define UINT_MAX      0xFFFFFFFF
#if BITS_PER_LONG == 32
#define LONG_MIN    (-2147483647L-1)
#define LONG_MAX      2147483647L
#define ULONG_MAX     0xFFFFFFFFUL
#elif BITS_PER_LONG == 64
#define LONG_MIN    (-9223372036854775807L-1)
#define LONG_MAX      9223372036854775807L
#define ULONG_MAX     0xFFFFFFFFFFFFFFFFUL
#endif
#define LLONG_MIN   (-9223372036854775807LL-1)
#define LLONG_MAX     9223372036854775807LL
#define ULLONG_MAX    0xFFFFFFFFFFFFFFFFULL
#ifdef _WIN32
#define WCHAR_MIN     0
#define WCHAR_MAX     0xFFFF
#else
#define WCHAR_MIN   (-2147483647-1)
#define WCHAR_MAX     2147483647
#endif

#ifdef __cplusplus
} // extern "C"
#endif
#endif
